<?php

use SilverStripe\Dev\BuildTask;
use SilverStripe\Control\HTTPRequest;
use SilverStripe\ORM\DB;
use SilverStripe\ORM\Queries\SQLUpdate;
use Fastrack\Property\Offer;
use Fastrack\Property\Property;

class PropertyOffersToGlobalOffers extends BuildTask
{

    private static $segment = 'PropertyOffersToGlobalOffers';

    public function getTitle()
    {
        return 'Convert Property Offers to Global Offers';
    }

    public function getDescription()
    {
        return 'Convert one-to-many to many-to-many';
    }

    /**
     * @param HTTPRequest $request
     */
    public function run($request)
    {

        $offers = Offer::get();
        foreach ($offers as $offer) {
            $propertyID = DB::query('SELECT PropertyID FROM offer WHERE ID=' . $offer->ID)->value();
            if ($propertyID) {
                $property = Property::get()->byID($propertyID);
                $offer->Properties()->add($property);
                SQLUpdate::create('"offer"')
                    ->addWhere(['ID' => $offer->ID])
                    ->assign('"PropertyID"', 0)
                    ->execute();
            }
        }
        $this->combineOffers();
    }

    private function combineOffers()
    {
        foreach (Offer::get() as $offer) {
            $matching = Offer::get()->filter(['Slug' => $offer->Slug])->exclude(['ID' => $offer->ID]);
            foreach ($matching as $match) {
                foreach ($match->Properties() as $property) {
                    $offer->Properties()->add($property);
                }
            }
        }
        $slugs = [];
        foreach (Offer::get() as $offer) {
            if (in_array($offer->Slug, $slugs)) {
                $offer->delete();
            } else {
                $slugs[] = $offer->Slug;
            }
        }
    }

}
